// Code generated by goa v3.12.3, DO NOT EDIT.
//
// task client HTTP transport
//
// Command:
// $ goa gen gitlab.eclipse.org/eclipse/xfsc/tsa/task/design

package client

import (
	"context"
	"net/http"

	goahttp "goa.design/goa/v3/http"
	goa "goa.design/goa/v3/pkg"
)

// Client lists the task service endpoint HTTP clients.
type Client struct {
	// Create Doer is the HTTP client used to make requests to the Create endpoint.
	CreateDoer goahttp.Doer

	// TaskResult Doer is the HTTP client used to make requests to the TaskResult
	// endpoint.
	TaskResultDoer goahttp.Doer

	// RestoreResponseBody controls whether the response bodies are reset after
	// decoding so they can be read again.
	RestoreResponseBody bool

	scheme  string
	host    string
	encoder func(*http.Request) goahttp.Encoder
	decoder func(*http.Response) goahttp.Decoder
}

// NewClient instantiates HTTP clients for all the task service servers.
func NewClient(
	scheme string,
	host string,
	doer goahttp.Doer,
	enc func(*http.Request) goahttp.Encoder,
	dec func(*http.Response) goahttp.Decoder,
	restoreBody bool,
) *Client {
	return &Client{
		CreateDoer:          doer,
		TaskResultDoer:      doer,
		RestoreResponseBody: restoreBody,
		scheme:              scheme,
		host:                host,
		decoder:             dec,
		encoder:             enc,
	}
}

// Create returns an endpoint that makes HTTP requests to the task service
// Create server.
func (c *Client) Create() goa.Endpoint {
	var (
		encodeRequest  = EncodeCreateRequest(c.encoder)
		decodeResponse = DecodeCreateResponse(c.decoder, c.RestoreResponseBody)
	)
	return func(ctx context.Context, v any) (any, error) {
		req, err := c.BuildCreateRequest(ctx, v)
		if err != nil {
			return nil, err
		}
		err = encodeRequest(req, v)
		if err != nil {
			return nil, err
		}
		resp, err := c.CreateDoer.Do(req)
		if err != nil {
			return nil, goahttp.ErrRequestError("task", "Create", err)
		}
		return decodeResponse(resp)
	}
}

// TaskResult returns an endpoint that makes HTTP requests to the task service
// TaskResult server.
func (c *Client) TaskResult() goa.Endpoint {
	var (
		decodeResponse = DecodeTaskResultResponse(c.decoder, c.RestoreResponseBody)
	)
	return func(ctx context.Context, v any) (any, error) {
		req, err := c.BuildTaskResultRequest(ctx, v)
		if err != nil {
			return nil, err
		}
		resp, err := c.TaskResultDoer.Do(req)
		if err != nil {
			return nil, goahttp.ErrRequestError("task", "TaskResult", err)
		}
		return decodeResponse(resp)
	}
}
